﻿/*

 Made By Sylvain Robert 2004-01-23
 Modified for MiniGUI by Grigory Filatov 2007-10-26
 Modified for Hmg by Mustafa López & el Rateret del Culebrón-Xinorlet 2018

*/

#include <minigui.ch>
#include <hmg_BoxLetterShow.ch>
#include <Viewry.prg>
#include <About.prg>
*------------------------------------------------------------------------------*
FUNCTION Main
*------------------------------------------------------------------------------*
  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET TOOLTIPSTYLE BALLOON
*----------------------------------*
  CLOSE DATABASES

  PUBLIC Tipx := "*.*"
 
  DEFINE WINDOW Form_1           ;
	AT 0, 0                  ;
	WIDTH 405 HEIGHT 310     ; 
	TITLE "Back-Up Demo Zip" ;
	ICON "Logo"              ;
        BACKCOLOR {128,128,255}  ;  
	MAIN                     ;
	NOMAXIMIZE NOSIZE        ;
	FONT "Arial" SIZE 9

        ON KEY ESCAPE ACTION  Form_1.Release

        DEFINE TIMER Timer_1 INTERVAL 1000  ACTION (RELEASE MEMORY)
   
        DEFINE TIMER Timer_2 ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 230, thisWindow.Col := 480 }  

        MiFrame( 025,020,360,44,"Frame_00","Selection Extensions for Back-Up",{ 007 ,002 , 204},{ 128,128,255} )       

         DEFINE RADIOGROUP Radio_1
                ROW   32
                COL   32
                OPTIONS { ' *.*',' *.Docx ',' *.Xlsx ',' *.Dbf',' *.Pdf',' *.Jpg' }   
                BACKCOLOR {128,128,255}    
                VALUE 1 
                WIDTH 100 
                TOOLTIP 'RadioGroup' 
                HORIZONTAL .T.
                SPACING 058
                ONCHANGE Change_Radius()
         END RADIOGROUP

 	 DEFINE BUTTON Button_1
		ROW 163
		COL 045
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(04)-"&Create Backup"
		ACTION Initius_CreateZip()   
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Create Backup"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Acep1.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_2
		ROW 163
		COL 205
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(02)-"&Recover Backup"
		ACTION Initius_CreateUnZip() 
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Recover Backup"
                FONTBOLD .T.
                FONTITALIC .T.   
                PICTURE "Resource\Acep2.bmp"     
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_3
		ROW 213
		COL 045
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(05)-"&View Zip"
		ACTION  VerBaseZip()
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "View Zip"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Viewx0.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_4
		ROW 213
		COL 205
		WIDTH 150
		HEIGHT 32
		CAPTION SPACE(09)-"&Exit"
		ACTION Form_1.Release
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Exit"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Cancel.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

         DEFINE LABEL Title    // Progress Bar
                ROW  079  
		COL  150 
		WIDTH 350  
		HEIGHT 20
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .F.
	 END LABEL

	 DEFINE PROGRESSBAR ProgressBar_1
		ROW 103
		COL 045
		WIDTH 310
		HEIGHT 25
		RANGEMIN 0   
		RANGEMAX 100  
		VALUE 0
		FORECOLOR {000,130,000}
	 END PROGRESSBAR

	 DEFINE LABEL Label_1
		ROW 133  
		COL 025
		WIDTH 350
		HEIGHT 20
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .T.
	 END LABEL

         SETWINDOWCURSOR ( Form_1.Button_4.Handle, "Resource\SmoothHand.cur")  
 
  END WINDOW

  CENTER WINDOW Form_1
  ACTIVATE WINDOW Form_1

Return

*----------------------------------*
FUNCTION Change_Radius()
*----------------------------------*

DO CASE 

CASE Form_1.Radio_1.Value == 0
     Tipx := "*.*"
CASE Form_1.Radio_1.Value == 1
     Tipx := "*.*"
CASE Form_1.Radio_1.Value == 2
     Tipx := "*.Docx"
CASE Form_1.Radio_1.Value == 3
     Tipx := "*.Xlsx" 
CASE Form_1.Radio_1.Value == 4
     Tipx := "*.Dbf"         
CASE Form_1.Radio_1.Value == 5
     Tipx := "*.Pdf"    
CASE Form_1.Radio_1.Value == 6
     Tipx := "*.Jpg"  

ENDCASE

RETURN

*------------------------------------------------------------------------------*
Function Initius_CreateZip()
*------------------------------------------------------------------------------*

 PRIVATE nX

 Form_1.Title.Value   := " " 
 Form_1.Label_1.Value := " " 

 CreateZip() 
   
 For nX := 0 to 100 step 1

    DO EVENTS 

    Form_1.Title.Value := "Progress: " + Str(nX,3)+" %"
    Form_1.ProgressBar_1.Value := nX    
    Form_1.ProgressBar_1.Refresh()   

   MILLISEC(80)      
 
 Next  

   MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}

   Form_1.ProgressBar_1.Value := 0
   Form_1.Title.Value := " "
   Form_1.Label_1.Value := 'Backup is finished'

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function CreateZip()
*------------------------------------------------------------------------------*

 PRIVATE cFileD := GetFolder () 
 PRIVATE aDir   := Directory( cFileD +"\"+ Tipx , "D"   ) 
 PRIVATE cPath  := cFileD +"\" 
 PRIVATE DirXY  :="Compress_Zip\" 
 PRIVATE ficXq  := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  
 PRIVATE aFiles := {}
 PRIVATE nLen , Typo , firaax ,  NuevoT
 PRIVATE FDIA ,FDIAx ,HORA , HORAx ,HORYx , HORy 
 PRIVATE Date_Copy         
 PRIVATE Nome_Zip    

*-------------------------------------------------------------------------------*
 FDIA    := DTOC(DATE())
 FDIAx   := STRTRAN(FDIA, '/')     && <--------  eliminas la barra(/)
 HORYx   := SUBSTR(TIME(),4,5)     && <-------   hora por detras
 HORy    := STRTRAN( HORYx , ':')  && <--------  eliminas los dos puntos(:)
 HORA    := LEFT(TIME(), 5)        && <-------   hora por delante
 HORAx   := STRTRAN(HORA, ':')     && <--------  eliminas los dos puntos(:)
*-------------------------------------------------------------------------------*
 Typo  :=  Tipx    
 firaax := RIGHT( Typo  , LEN(Typo ) - RAT(".", Typo  ))  
 NuevoT =  LEFT ( firaax , LEN( firaax ) )   
*------------------------------------------------------------------------------------------------------*

 IF  NuevoT = "*"
     Date_Copy :="\"+ ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + "_["+ CHR(149) +"."+CHR(149) + "].Zip"      
     Nome_Zip  :=     ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + "_["+ CHR(149) +"."+CHR(149) + "].Zip"     
 ELSE
     Date_Copy :="\"+ ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + "_["+ ALLTRIM(NuevoT) + "].Zip"  
     Nome_Zip  :=     ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + "_["+ ALLTRIM(NuevoT) + "].Zip"       
 ENDIF

*------------------------------------------------------------------------------------------------------*
 IF ! HB_DirExists( DirXY)
     DirMake( DirXY )
 ENDIF

  IF Empty(cFileD )
    	msginfo("Please select Source Folder", "Attenttion !!!")
        MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}
        Form_1.ProgressBar_1.Value := 0
        Form_1.Title.Value := " "
        Form_1.Label_1.Value := 'Backup is finished'
       	Return nil
 ENDIF 
   
 FillFiles( aFiles, aDir, cPath )

 IF ( nLen := Len(aFiles) ) > 0

         MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,000}

          COMPRESS aFiles ;
		TO 'Compress_Zip\'+ Date_Copy;
                BLOCK  {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;    
                OVERWRITE
*------------------------------- Back_Up Control.Dbf -------------------------*    

  CLOSE DATABASES
  SELECT 1  
  USE CONTROL 
  APPEND BLANK
  REPLACE DIR_ZIP  WITH cFileD +"\"   
  REPLACE NOM_ZIP  WITH Nome_Zip   
  REPLACE DATE_E   WITH DATE()
  REPLACE TIME_E   WITH TIME()
  REPLACE UN_ZIP   WITH .F.
  REPLACE TIME_S   WITH "00:00:00"
 ENDIF

 Form_1.Radio_1.Value := 1

Return Nil

*------------------------------------------------------------------------------*
Function ProgressUpdate( nPos , cFile , lShowFileName )
*------------------------------------------------------------------------------*
	Default lShowFileName := .F.
	Form_1.Label_1.Value := cFileNoPath( cFile )

	if lShowFileName
		INKEY(.1)
	endif

Return Nil

*------------------------------------------------------------------------------*
Function Initius_CreateUnZip()
*------------------------------------------------------------------------------*

 PRIVATE cDirQ := "Compress_Zip"
 PRIVATE nQ

 Form_1.Title.Value   := " " 
 Form_1.Label_1.Value := " " 

 IF ! HB_DirExists(cDirQ)
      MsgStop( SPACE(4) + cDirQ + CRLF + CRLF + "Directory not found!","Attenttion !!!" )
      Return (.F.)
 ENDIF

 CreateUnZip()

 For nQ  := 0 to 100 step 1

    DO EVENTS 

    Form_1.Title.Value := "Progress: " + Str(nQ,3)+" %"
    Form_1.ProgressBar_1.Value := nQ     
    Form_1.ProgressBar_1.Refresh()   

    MILLISEC(80)      
 
 Next  

   MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}
   Form_1.ProgressBar_1.Value := 0
   Form_1.Title.Value := " "
   Form_1.Label_1.Value := 'Backup is finished'
   Form_1.Radio_1.Value := 1

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function  CreateUnZip()
*------------------------------------------------------------------------------*

  PRIVATE cCurDir := GetCurrentFolder() , cArchive,  ficXq

  cArchive := Getfile ( { {'Zip Files','*.ZIP'} } , 'Open File' , cCurDir , .F. , .T. )
  ficXq  := RIGHT( cArchive , LEN(cArchive) - RAT("\", cArchive ) )  

  IF Empty( cArchive )
    	msginfo("Please select Source Folder", "Attenttion !!!")
        MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}
        Form_1.ProgressBar_1.Value := 0
        Form_1.Title.Value := " "
        Form_1.Label_1.Value := 'Backup is finished'
        Form_1.Radio_1.Value := 1
        Return nil
  ENDIF

  IF ! Empty( cArchive )
       CLOSE DATABASES
       SELECT 1  
       USE CONTROL 
       LOCATE FOR NOM_ZIP = ALLTRIM( ficXq )
       REPLACE UN_ZIP  WITH .T.
       REPLACE DATE_S  WITH DATE()
       REPLACE TIME_S  WITH TIME()

       MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,000}
       Form_1.ProgressBar_1.Value := 0
       Form_1.Title.Value := " "
       Form_1.Label_1.Value := 'Backup is finished'
       Form_1.Radio_1.Value := 1
    
            UNCOMPRESS cArchive ;
            BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } 
  ENDIF 

Return Nil

*------------------------------------------------------------------------------*
Function FillFiles( aFiles, cDir, cPath )
*------------------------------------------------------------------------------*
  PRIVATE aSubDir, cItem

  FOR cItem :=1 TO LEN(cDir)
    IF cDir[cItem][5] <> "D"
      AADD( aFiles, cPath+cDir[cItem][1] )
    ELSEIF cDir[cItem][1] <> "." .AND. cDir[cItem][1] <> ".."
      aSubDir := DIRECTORY( cPath+cDir[cItem][1]+"\*.*" )
      aFiles:=FillFiles( aFiles, aSubdir, cPath+cDir[cItem][1]+"\" )
    ENDIF
  NEXT

Return aFiles

*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*